#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

import os

VERSION = "4"

CELL_SHIFT = 4
TERMINAL_RADIUS = 10
INITIAL_LEVEL = 0

COLOUR_UNDEFINED = (120, 120, 120)
COLOUR_ONE = (0, 255, 0)
COLOUR_ZERO = (0, 80, 0)

COLOUR_WHITE = (255, 255, 255)
COLOUR_BLACK = (0, 0, 0)

HIGHLIGHT_COLOUR = (150, 150, 0)
GREY_LINE_COLOUR = (100, 150, 100)


HIGHLIGHT_INC = 5
SPECIAL_SIZE = (TERMINAL_RADIUS * 4)
SCROLL_SPEED = 10

COLOUR_DIVIDER = 3

SCROLL_TIMER_INTERVAL = 100 # ms
CLOCK_MINOR_INTERVAL = 120
CLOCK_MAJOR_INTERVAL = 1200

CLOCK_CYCLE_LENGTH = CLOCK_MAJOR_INTERVAL / CLOCK_MINOR_INTERVAL

IN_SEQ_WIDTH = 140
EXPANSION_WIDTH = 100
TREE_SIZE = (300, 300)
APP_NAME = "Christmas Logic"

SEQ_WIDTH = 15
SEQ_MARGIN = 20
SEQ_X_MARGIN = 30
SEQ_ONE_HEIGHT = 15
SEQ_ZERO_HEIGHT = 5

ST_UNDEFINED = "?"
ST_ONE = "1"
ST_ZERO = "0"
ST_CLOCK = "/"

SEARCH_STEP = 10

GUIDE_BOX_MARGIN = 5
GUIDE_BOX_WIDTH = 300
GUIDE_BOX_HEIGHT = 100
ARROW_OFFSET = 20
ARROW_SIZE = 40

DEFAULT_RATE_SETTING = 3
STRETCH = 2

OVERPAINT_DEBUG = False
LEVEL_WARP_CHEAT = False

STIM_COLOUR = [ (255, 255, 200), (200, 255, 200), 
        (255, 200, 255), (255, 200, 200) ]

IMAGE_PATH = os.path.join("data", "image")
LEVEL_PATH = os.path.join("data", "level")
INIT_CACHE_PATH = os.path.join("data", "icache")
CACHE_PATH = os.path.curdir
GAME_DB_FILE = "db.dat"

BACKGROUND_COLOUR = (239, 239, 239)

WORLD_BOUNDARY = 2000

