#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

import os, sys
from constants import *


__RO_DIR = __RW_DIR = None

def RO_DIR():
    return __RO_DIR

def RW_DIR():
    return __RW_DIR

def Start_Disk():
    global __RO_DIR, __RW_DIR
    home = os.environ.get("HOME", None)
    if home == None:
        home = os.environ.get("APPDATA", None)
    if home == None:
        home = os.path.curdir

    ro = __RO_DIR = os.getcwd()
    assert os.path.isdir(ro)

    if not (os.path.isdir(os.path.join(ro, IMAGE_PATH))
    or os.path.isdir(os.path.join(ro, LEVEL_PATH))
    or os.path.isdir(os.path.join(ro, INIT_CACHE_PATH))
    or os.path.isdir(os.path.join(ro, "src"))):
        print 'Game assets not found in "%s".' % ro
        sys.exit(1)

    nw = 'Home directory "%s" is not writable' % home
    if not os.path.isdir(home):
        print 'Home directory "%s" does not exist' % home
        sys.exit(1)

    assert os.path.isfile(os.path.join(LEVEL_PATH, "level00.py"))
    assert os.path.isfile(os.path.join(IMAGE_PATH, "santaicon.png"))

    __RW_DIR = rw = os.path.join(home, ".christmaslogic")
    if not os.path.isdir(rw):
        try:
            os.mkdir(rw)
        except:
            print nw
            sys.exit(1)
   
    try:
        file(os.path.join(rw, "test"), "wb").write("test")
    except:
        print nw
        sys.exit(1)
  
    copy_cache_from = os.path.join(ro, INIT_CACHE_PATH)
    for name in os.listdir(copy_cache_from):
        src = os.path.join(copy_cache_from, name)
        dest = os.path.join(rw, name)
        if ((not os.path.isfile(dest))
        and src.endswith(".png")):
            try:
                file(dest, "wb").write(file(src, "rb").read())
            except:
                print nw
                sys.exit(1)


